// Simple whitelist-based HTML filter application for CS 261 (Intro
// to Security) at UC Berkeley, Fall 2009.
//
// The author, XXX, releases all rights to this work and
// grants it into the public domain.

import java.io.*;
import org.htmlparser.*;
import org.htmlparser.util.*;
import org.htmlparser.visitors.*;

public class HtmlFilter {
    public static void main(String[] args) {
        try {
	    BufferedReader bufferedIn = new BufferedReader(new InputStreamReader(System.in));
	    String inputHtml = "", line;
	    while ((line = bufferedIn.readLine()) != null) {
		inputHtml += line + "\n";
	    }
	    Parser parser = Parser.createParser(inputHtml, null);
            NodeList nodeList = parser.parse(null);
            nodeList.keepAllNodesThatMatch(new HtmlFilterNodeFilter(), /*recursive*/true);
            nodeList.visitAllNodesWith(new HtmlFilterNodeVisitor());
            System.out.println(nodeList.toHtml());
        }
        catch (Exception e) {
            System.out.println("Your page could not be displayed. An unexpected error occurred.");
            //System.out.println(e.getMessage());
            //e.printStackTrace();
	}
    }
}
