// Simple whitelist-based HTML filter application for CS 261 (Intro
// to Security) at UC Berkeley, Fall 2009.
//
// The author, XXX, releases all rights to this work and
// grants it into the public domain.

import java.io.*;
import java.util.*;
import org.htmlparser.*;
import org.htmlparser.util.*;
import org.htmlparser.visitors.*;

public class HtmlFilterNodeFilter implements NodeFilter {
    List<String> elementWhitelist;

    public HtmlFilterNodeFilter() throws java.io.IOException {
	String line;
	BufferedReader bufferedIn;

        elementWhitelist = new ArrayList<String>();
        bufferedIn = new BufferedReader(new FileReader(new File("elementwhitelist")));
	while ((line = bufferedIn.readLine()) != null) {
	    elementWhitelist.add(line);
	}
    }

    public boolean accept(Node node) {
        //if (node instanceof Tag) {
        //    System.out.println(((Tag)node).getTagName() + ": " + elementWhitelist.contains(((Tag)node).getTagName()));
	//}
	return (node instanceof Text) ||
               (node instanceof Tag && elementWhitelist.contains(((Tag)node).getTagName()));
    }
}
