// Simple whitelist-based HTML filter application for CS 261 (Intro
// to Security) at UC Berkeley, Fall 2009.
//
// The author, XXX, releases all rights to this work and
// grants it into the public domain.

import java.io.*;
import java.util.*;
import org.htmlparser.*;
import org.htmlparser.util.*;
import org.htmlparser.visitors.*;

public class HtmlFilterNodeVisitor extends NodeVisitor {
    List<String> elementWhitelist;
    List<String> attributeWhitelist;

    public HtmlFilterNodeVisitor() throws java.io.IOException {
	String line;
	BufferedReader bufferedIn;

        attributeWhitelist = new ArrayList<String>();
        bufferedIn = new BufferedReader(new FileReader(new File("attributewhitelist")));
	while ((line = bufferedIn.readLine()) != null) {
	    attributeWhitelist.add(line);
	}
    }

    public void visitTag(Tag tag) {
        Vector attributes = tag.getAttributesEx();
        Iterator iter = attributes.iterator();
        List<String> attributesToRemove = new ArrayList<String>();
        iter.next(); // Tag name
        while (iter.hasNext()) {
            iter.next(); // Skip interleaved null
            Attribute attribute = (Attribute)iter.next();
            if (!attributeWhitelist.contains(attribute.getName()) &&
                !attributeWhitelist.contains(tag.getTagName() + "." + attribute.getName())) {
                //System.out.println("Removing: " + tag.getTagName() + "." + attribute.getName());
                attributesToRemove.add(attribute.getName());
            }
        }
        Iterator<String> iterStr = attributesToRemove.iterator();
        while (iterStr.hasNext()) {
            tag.removeAttribute(iterStr.next());
	}
    }

    public void visitStringNode(Text string) {
	// No action required
    }
}
